function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import AutoSizer from 'react-virtualized-auto-sizer';
import Button from '@material-ui/core/Button';
import Divider from '@material-ui/core/Divider';
import FilterDrawer from 'material-ui-shell/lib/components/FilterDrawer';
import FilterList from '@material-ui/icons/FilterList';
import IconButton from '@material-ui/core/IconButton';
import List from '@material-ui/core/List';
import ListItem from '@material-ui/core/ListItem';
import ListItemText from '@material-ui/core/ListItemText';
import Page from 'material-ui-shell/lib/containers/Page';
import React, { useEffect, createRef, forwardRef, useCallback, useReducer } from 'react';
import Scrollbar from 'material-ui-shell/lib/components/Scrollbar';
import SearchField from 'material-ui-shell/lib/components/SearchField';
import Toolbar from '@material-ui/core/Toolbar';
import Typography from '@material-ui/core/Typography';
import { FixedSizeList } from 'react-window';
import { Scrollbars } from 'react-custom-scrollbars';
import { useFilter } from 'material-ui-shell/lib/providers/Filter';
import { useIntl } from 'react-intl';
import { useState } from 'react';
import { setScrollOffset } from '../../providers/Filter/store/actions';
var CustomScrollbarsVirtualList = React.forwardRef(function (props, ref) {
  var style = props.style,
      rest = _objectWithoutPropertiesLoose(props, ["style"]);

  return /*#__PURE__*/React.createElement(Scrollbar, _extends({}, rest, {
    forwardedRef: ref,
    style: _extends(_extends({}, style), {}, {
      overflow: 'hidden'
    })
  }));
});
export default function (props) {
  var _props$fields = props.fields,
      fields = _props$fields === void 0 ? [] : _props$fields,
      _props$list = props.list,
      source = _props$list === void 0 ? [] : _props$list,
      _props$getPageProps = props.getPageProps,
      getPageProps = _props$getPageProps === void 0 ? function () {} : _props$getPageProps,
      listProps = props.listProps,
      Row = props.Row,
      name = props.name,
      _props$setListRef = props.setListRef,
      setListRef = _props$setListRef === void 0 ? function () {} : _props$setListRef,
      _props$initialIndex = props.initialIndex,
      initialIndex = _props$initialIndex === void 0 ? 0 : _props$initialIndex,
      _props$preserveScroll = props.preserveScroll,
      preserveScroll = _props$preserveScroll === void 0 ? true : _props$preserveScroll;
  var intl = useIntl();
  var listRef = React.createRef();

  var _useState = useState(false),
      ref = _useState[0],
      setRef = _useState[1];

  var _useFilter = useFilter(),
      openFilter = _useFilter.openFilter,
      getList = _useFilter.getList,
      getFilter = _useFilter.getFilter,
      setSearch = _useFilter.setSearch,
      setScrollOffset = _useFilter.setScrollOffset;

  var _getFilter = getFilter(name),
      _getFilter$queries = _getFilter.queries,
      queries = _getFilter$queries === void 0 ? [] : _getFilter$queries,
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search,
      _getFilter$scrollOffs = _getFilter.scrollOffset,
      scrollOffset = _getFilter$scrollOffs === void 0 ? 0 : _getFilter$scrollOffs;

  var _search$value = search.value,
      searchvalue = _search$value === void 0 ? '' : _search$value;
  var list = getList(name, source, fields);
  useEffect(function () {
    if (preserveScroll && ref && scrollOffset) {
      listRef.current.scrollTo(scrollOffset);
    }
  }, [ref]);
  useEffect(function () {
    return function () {
      try {
        if (preserveScroll) {
          var offset = listRef.current.state.scrollOffset;
          setScrollOffset(name, offset);
        }
      } catch (error) {
        console.warn('Could not save scrollOffset');
      }
    };
  }, []);
  return /*#__PURE__*/React.createElement(Page, _extends({
    contentStyle: {
      overflow: 'hidden'
    },
    appBarContent: /*#__PURE__*/React.createElement(Toolbar, {
      disableGutters: true
    }, /*#__PURE__*/React.createElement(SearchField, {
      initialValue: searchvalue,
      onChange: function onChange(v) {
        setSearch(name, v);
      }
    }), /*#__PURE__*/React.createElement(IconButton, {
      color: "inherit",
      onClick: function onClick() {
        return openFilter(name);
      }
    }, /*#__PURE__*/React.createElement(FilterList, {
      color: queries.length > 0 ? 'secondary' : undefined
    })))
  }, getPageProps(list)), /*#__PURE__*/React.createElement(AutoSizer, {
    style: {
      height: '100%',
      width: '100%'
    }
  }, function (_ref) {
    var height = _ref.height,
        width = _ref.width;
    return /*#__PURE__*/React.createElement(List, null, /*#__PURE__*/React.createElement(FixedSizeList, _extends({
      ref: function ref(r) {
        if (r) {
          listRef.current = r;
          setRef(true);
        }
      },
      height: height,
      itemCount: list.length,
      width: width,
      outerElementType: CustomScrollbarsVirtualList
    }, listProps), Row));
  }), /*#__PURE__*/React.createElement(FilterDrawer, {
    fields: fields,
    name: name
  }));
}