"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ResponsiveMenu = _interopRequireDefault(require("../ResponsiveMenu/ResponsiveMenu"));

var _Scrollbar = _interopRequireDefault(require("material-ui-shell/lib/components/Scrollbar/Scrollbar"));

var _SelectableMenuList = _interopRequireDefault(require("material-ui-shell/lib/containers/SelectableMenuList"));

var _AddToHomeScreen = require("base-shell/lib/providers/AddToHomeScreen");

var _Auth = require("base-shell/lib/providers/Auth");

var _Config = require("base-shell/lib/providers/Config");

var _reactRouterDom = require("react-router-dom");

var _reactIntl = require("react-intl");

var _Locale = require("base-shell/lib/providers/Locale");

var _Menu = require("material-ui-shell/lib/providers/Menu");

var _Theme = require("material-ui-shell/lib/providers/Theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Menu = function Menu(props) {
  var intl = (0, _reactIntl.useIntl)();
  var history = (0, _reactRouterDom.useHistory)();
  var match = (0, _reactRouterDom.useRouteMatch)();
  var auth = (0, _Auth.useAuth)();
  var menuContext = (0, _Menu.useMenu)();
  var a2HSContext = (0, _AddToHomeScreen.useAddToHomeScreen)();

  var _ref = menuContext || {},
      isDesktopOpen = _ref.isDesktopOpen,
      isMini = _ref.isMini,
      setDesktopOpen = _ref.setDesktopOpen,
      setMobileOpen = _ref.setMobileOpen,
      useMiniMode = _ref.useMiniMode;

  var _useConfig = (0, _Config.useConfig)(),
      appConfig = _useConfig.appConfig;

  var _useLocale = (0, _Locale.useLocale)(),
      setLocale = _useLocale.setLocale,
      _useLocale$locale = _useLocale.locale,
      locale = _useLocale$locale === void 0 ? 'en' : _useLocale$locale;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var _ref3 = menu || {},
      MenuHeader = _ref3.MenuHeader,
      getMenuItems = _ref3.getMenuItems;

  var themeContext = (0, _Theme.useTheme)();
  var menuItems = getMenuItems(_extends({
    intl,
    locale,
    updateLocale: setLocale,
    menuContext,
    themeContext,
    appConfig,
    a2HSContext,
    auth
  }, props)).filter(function (item) {
    return item.visible !== false;
  });
  var index = match ? match.path : '/';

  var handleChange = function handleChange(event, index) {
    if (index !== undefined) {
      setMobileOpen(false);
    }

    if (index !== undefined && index !== Object(index)) {
      history.push(index);
    }
  };

  return /*#__PURE__*/_react.default.createElement(_ResponsiveMenu.default, null, MenuHeader && /*#__PURE__*/_react.default.createElement(MenuHeader, null), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%'
    }
  }, /*#__PURE__*/_react.default.createElement(_Scrollbar.default, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/_react.default.createElement(_SelectableMenuList.default, {
    items: menuItems,
    onIndexChange: handleChange,
    index: index,
    key: useMiniMode,
    useMinified: isMini && !isDesktopOpen
  }))));
};

var _default = Menu;
exports.default = _default;
module.exports = exports.default;