"use strict";

exports.__esModule = true;
exports.default = _default;

var _reactVirtualizedAutoSizer = _interopRequireDefault(require("react-virtualized-auto-sizer"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _FilterDrawer = _interopRequireDefault(require("material-ui-shell/lib/components/FilterDrawer"));

var _FilterList = _interopRequireDefault(require("@material-ui/icons/FilterList"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Page = _interopRequireDefault(require("material-ui-shell/lib/containers/Page"));

var _react = _interopRequireWildcard(require("react"));

var _Scrollbar = _interopRequireDefault(require("material-ui-shell/lib/components/Scrollbar"));

var _SearchField = _interopRequireDefault(require("material-ui-shell/lib/components/SearchField"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _reactWindow = require("react-window");

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _Filter = require("material-ui-shell/lib/providers/Filter");

var _reactIntl = require("react-intl");

var _actions = require("../../providers/Filter/store/actions");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CustomScrollbarsVirtualList = _react.default.forwardRef(function (props, ref) {
  var style = props.style,
      rest = _objectWithoutPropertiesLoose(props, ["style"]);

  return /*#__PURE__*/_react.default.createElement(_Scrollbar.default, _extends({}, rest, {
    forwardedRef: ref,
    style: _extends(_extends({}, style), {}, {
      overflow: 'hidden'
    })
  }));
});

function _default(props) {
  var _props$fields = props.fields,
      fields = _props$fields === void 0 ? [] : _props$fields,
      _props$list = props.list,
      source = _props$list === void 0 ? [] : _props$list,
      _props$getPageProps = props.getPageProps,
      getPageProps = _props$getPageProps === void 0 ? function () {} : _props$getPageProps,
      listProps = props.listProps,
      Row = props.Row,
      name = props.name,
      _props$setListRef = props.setListRef,
      setListRef = _props$setListRef === void 0 ? function () {} : _props$setListRef,
      _props$initialIndex = props.initialIndex,
      initialIndex = _props$initialIndex === void 0 ? 0 : _props$initialIndex,
      _props$preserveScroll = props.preserveScroll,
      preserveScroll = _props$preserveScroll === void 0 ? true : _props$preserveScroll;
  var intl = (0, _reactIntl.useIntl)();

  var listRef = _react.default.createRef();

  var _useState = (0, _react.useState)(false),
      ref = _useState[0],
      setRef = _useState[1];

  var _useFilter = (0, _Filter.useFilter)(),
      openFilter = _useFilter.openFilter,
      getList = _useFilter.getList,
      getFilter = _useFilter.getFilter,
      setSearch = _useFilter.setSearch,
      setScrollOffset = _useFilter.setScrollOffset;

  var _getFilter = getFilter(name),
      _getFilter$queries = _getFilter.queries,
      queries = _getFilter$queries === void 0 ? [] : _getFilter$queries,
      _getFilter$search = _getFilter.search,
      search = _getFilter$search === void 0 ? {} : _getFilter$search,
      _getFilter$scrollOffs = _getFilter.scrollOffset,
      scrollOffset = _getFilter$scrollOffs === void 0 ? 0 : _getFilter$scrollOffs;

  var _search$value = search.value,
      searchvalue = _search$value === void 0 ? '' : _search$value;
  var list = getList(name, source, fields);
  (0, _react.useEffect)(function () {
    if (preserveScroll && ref && scrollOffset) {
      listRef.current.scrollTo(scrollOffset);
    }
  }, [ref]);
  (0, _react.useEffect)(function () {
    return function () {
      try {
        if (preserveScroll) {
          var offset = listRef.current.state.scrollOffset;
          setScrollOffset(name, offset);
        }
      } catch (error) {
        console.warn('Could not save scrollOffset');
      }
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_Page.default, _extends({
    contentStyle: {
      overflow: 'hidden'
    },
    appBarContent: /*#__PURE__*/_react.default.createElement(_Toolbar.default, {
      disableGutters: true
    }, /*#__PURE__*/_react.default.createElement(_SearchField.default, {
      initialValue: searchvalue,
      onChange: function onChange(v) {
        setSearch(name, v);
      }
    }), /*#__PURE__*/_react.default.createElement(_IconButton.default, {
      color: "inherit",
      onClick: function onClick() {
        return openFilter(name);
      }
    }, /*#__PURE__*/_react.default.createElement(_FilterList.default, {
      color: queries.length > 0 ? 'secondary' : undefined
    })))
  }, getPageProps(list)), /*#__PURE__*/_react.default.createElement(_reactVirtualizedAutoSizer.default, {
    style: {
      height: '100%',
      width: '100%'
    }
  }, function (_ref) {
    var height = _ref.height,
        width = _ref.width;
    return /*#__PURE__*/_react.default.createElement(_List.default, null, /*#__PURE__*/_react.default.createElement(_reactWindow.FixedSizeList, _extends({
      ref: function ref(r) {
        if (r) {
          listRef.current = r;
          setRef(true);
        }
      },
      height: height,
      itemCount: list.length,
      width: width,
      outerElementType: CustomScrollbarsVirtualList
    }, listProps), Row));
  }), /*#__PURE__*/_react.default.createElement(_FilterDrawer.default, {
    fields: fields,
    name: name
  }));
}

module.exports = exports.default;